SuperStrict
Framework brl.blitz
Import brl.max2d
?Win32
Import brl.d3d9max2d
?Linux
Import brl.glmax2d
?
Import brl.Graphics
Import brl.timer
Import brl.filesystem
Import brl.retro
Import brl.pngloader

Include "lang-de.bmx"

Const GW:Int			= 640
Const GH:Int			= 480
Const FELD_BREITE_STD:Int	= GH / 20
Const INITLEV:String		= "init.bin"
Const HIGHSCOREF:String	= "highscore.bin"
Const GFXF:String			= "gfx.png"
Const GFXHG:String		= "hg.png"
Const FBLACKLIST:String	= "blacklist.txt"

Global corruptlevlist:String[]
Global gfx:TImage,hg:TImage
Global dir:String
Global FELD_BREITE:Int=FELD_BREITE_STD
Global timer:TTimer=CreateTimer(40)
Global currentlevel:String,nextlevel:String
Global player_dir:Int

AppTitle="Dump Box"
Graphics GW, GH
SetBlend ALPHABLEND

If FileType(FBLACKLIST)=1 Then LoadCorrupt
Menu
If corruptlevlist.length Then SaveCorrupt
End

Function LoadCorrupt()
	Local datei:TStream=ReadFile(FBLACKLIST)
	Local s:String
	While Not Eof(datei)
		s=ReadLine(datei)
		If s And FileType(s)=2 Then corruptlevlist:+[s]
	Wend
	CloseFile datei
EndFunction

Function SaveCorrupt()
	Local datei:TStream=WriteFile(FBLACKLIST)
	For Local s:String=EachIn corruptlevlist
		WriteLine datei,s
	Next
	CloseFile datei
EndFunction

Type TTeleport
	Global list:TTeleport[]
	Field src_x:Byte, src_y:Byte
	Field dst_x:Byte, dst_y:Byte
	Function Create:TTeleport(src_x:Int,src_y:Int,dst_x:Int,dst_y:Int)
		Local t:TTeleport=New TTeleport
		t.src_x=src_x; t.src_y=src_y; t.dst_x=dst_x; t.dst_y=dst_y
		list:+[t]
	EndFunction
	Function drawall(zentral_x:Int,zentral_y:Int)
		For Local t:TTeleport=EachIn list
			t.draw zentral_x,zentral_y
		Next
	EndFunction
	Function boxteleport(feld:Byte[,] Var, pos_x:Int, pos_y:Int)
		For Local t:TTeleport=EachIn list
			If t.src_x=pos_x And t.src_y=pos_y And feld[t.dst_x,t.dst_y]&$4=0 Then
				feld[pos_x,pos_y]:&(~$4)
				feld[t.dst_x,t.dst_y]:|$4
				Return
			ElseIf t.dst_x=pos_x And t.dst_y=pos_y And feld[t.src_x,t.src_y]&$4=0 Then
				feld[pos_x,pos_y]:&(~$4)
				feld[t.src_x,t.src_y]:|$4
				Return
			EndIf
		Next		
	EndFunction
	Function playerteleport(feld:Byte[,] Var, pos_x:Int Var, pos_y:Int Var, mov_x:Int, mov_y:Int)
		Local movok:Int=0, t:TTeleport
		For t=EachIn list
			If t.src_x=pos_x And t.src_y=pos_y Then
				movok=1
				If feld[t.dst_x,t.dst_y]&$4 Then

					If t.dst_x+mov_x<0 Or t.dst_x+mov_x>=feld.dimensions()[0] Or t.dst_y+mov_y<0 Or ..
											t.dst_y+mov_y>=feld.dimensions()[1] Then movok=0;Exit
					If feld[t.dst_x+mov_x,t.dst_y+mov_y]&$4 Or feld[t.dst_x+mov_x,t.dst_y+mov_y]&$3=0 Then
						feld[t.dst_x,t.dst_y]:&(~$4)
						feld[pos_x,pos_y]:|$4
					EndIf
				EndIf
				If movok Then
					pos_x=t.dst_x
					pos_y=t.dst_y
				EndIf
				Exit
			ElseIf t.dst_x=pos_x And t.dst_y=pos_y Then
				movok=1
				If feld[t.src_x,t.src_y]&$4 Then
					If t.src_x+mov_x<0 Or t.src_x+mov_x>=feld.dimensions()[0] Or t.src_y+mov_y<0 Or ..
											t.src_y+mov_y>=feld.dimensions()[1] Then movok=0;Exit
					If feld[t.src_x+mov_x,t.src_y+mov_y]&$4 Or feld[t.src_x+mov_x,t.src_y+mov_y]&$3=0 Then
						feld[t.src_x,t.src_y]:&(~$4)
						feld[pos_x,pos_y]:|$4
					EndIf
				EndIf
				If movok Then
					pos_x=t.src_x
					pos_y=t.src_y
				EndIf
				Exit

			EndIf
		Next
		If feld[pos_x,pos_y]&$4 And feld[pos_x+mov_x,pos_y+mov_y]&$4=0 And movok Then
			feld[pos_x,pos_y]:&(~$4)
			feld[pos_x+mov_x,pos_y+mov_y]:|$4
		ElseIf Not movok And t Then
			If t.dst_x=pos_x And t.dst_y=pos_y And feld[t.src_x,t.src_y]&$4 Then
				feld[t.src_x,t.src_y]:&(~$4)
				feld[t.dst_x,t.dst_y]:|$4
				pos_x=t.src_x ; pos_y=t.src_y
			ElseIf t.src_x=pos_x And t.src_y=pos_y And feld[t.dst_x,t.dst_y]&$4 Then
				feld[t.dst_x,t.dst_y]:&(~$4)
				feld[t.src_x,t.src_y]:|$4
				pos_x=t.dst_x ; pos_y=t.dst_y
			EndIf
		EndIf
	EndFunction
	Method draw(zentral_x:Int,zentral_y:Int)
		If gfx Then
			SetColor 255,255,255
			DrawImage gfx,zentral_x+src_x*FELD_BREITE,zentral_y+src_y*FELD_BREITE,9
			DrawImage gfx,zentral_x+dst_x*FELD_BREITE,zentral_y+dst_y*FELD_BREITE,9
		Else
			SetColor 255,255,0
			DrawRect zentral_x+src_x*FELD_BREITE+FELD_BREITE/2-3,zentral_y+src_y*FELD_BREITE,6,FELD_BREITE
			DrawRect zentral_x+dst_x*FELD_BREITE,zentral_y+dst_y*FELD_BREITE+FELD_BREITE/2-3,FELD_BREITE,6
		EndIf
	EndMethod
EndType

Function mousein:Int(x:Int,y:Int,w:Int,h:Int)
	Local mx:Int=MouseX(), my:Int=MouseY()
	Return mx>x And mx<x+w And my>y And my<y+h
EndFunction

Function DrawButton:Int(s:String,x:Int,y:Int,w:Int,h:Int)
	Local ret:Int
	If mousein(x,y,w,h) Then
		ret=1
		If MouseHit(MOUSE_LEFT) Then ret=2 ..
		ElseIf MouseDown(MOUSE_RIGHT) Then ret=3
	EndIf
	If ret<>3 Then SetColor 160,160,255 Else SetColor 255,140,130
	DrawRect x,y,w,h
	SetColor 0,0,0
	DrawText s,x+(w-TextWidth(s))/2,y+(h-TextHeight(s))/2
	
	If ret Then
		SetColor 0,0,0
		DrawRect x+(w-TextWidth(s))/2-1,y+(h+TextHeight(s))/2-2,TextWidth(s)+2,2
	EndIf
	Return ret
EndFunction

Const SCORE_PLAETZE:Int=4
Const SCORE_NAMELEN:Int=10
Function DeleteHighscore(level:String)
	If FileType(level+"/"+HIGHSCOREF) Then DeleteFile level+"/"+HIGHSCOREF
	CleanHighscore level
EndFunction
Function CleanHighscore(level:String)
	Local datei:TStream, name:String=STR_STDNAME, k:Int
	datei=WriteFile(level+"/"+HIGHSCOREF)
	For Local i:Int=1 To SCORE_PLAETZE
		WriteString datei,name
		k=name.length
		While k<SCORE_NAMELEN ; WriteByte datei,32 ; k:+1 ; Wend
		WriteInt datei,$7FFFFFFF
	Next
	CloseFile datei
EndFunction
Function LoadHighscore(level:String, name:String[] Var,  score:Int[] Var)
	Local datei:TStream
	name=Null ; score=Null
	If FileType(level+"/"+HIGHSCOREF)<>1 Or ..
			FileSize(level+"/"+HIGHSCOREF)<>SCORE_PLAETZE*(SCORE_NAMELEN+4) Then ..
					CleanHighscore level;Return
	datei=ReadFile(level+"/"+HIGHSCOREF)
	For Local i:Int=1 To SCORE_PLAETZE
		name:+[ReadString(datei,SCORE_NAMELEN)]
		score:+[ReadInt(datei)]
	Next
	CloseFile datei
EndFunction
Function SaveHighscore(level:String, name:String[],  score:Int[])
	Local datei:TStream, i:Int, k:Int
	datei=WriteFile(level+"/"+HIGHSCOREF)
	For i=0 Until SCORE_PLAETZE
		WriteString datei,name[i]
		k=name[i].length
		While k<SCORE_NAMELEN ; WriteByte datei,32 ; k:+1 ; Wend
		WriteInt datei,score[i]
	Next
	CloseFile datei
EndFunction

Function Menu()
	Local this:String[]=LoadDir("."), score:Int[], scorelevel:String
	Local group:String[], sx:Int, sy:Int, tmp:Int, s:String, W:Int
	Local newload:Float, delsince:Int, dellevel:String, oklev:Int
	For Local s:String=EachIn this
		If s.endswith(".lev") And FileType(s)=2 And Not iscorrupt(s) Then group:+[s]
	Next
	this=Null
	Repeat
		Cls
		
		
		SetColor 255,160,0
		DrawText AppTitle,10,10
		
		sx=10
		sy=60
		
		For Local s:String=EachIn group
			sy:+20
			w=TextWidth(s[..s.length-4])+10
			If w<100 Then w=100
			tmp=DrawButton(s[..s.length-4],sx,sy,w,18)
			If s=scorelevel Then
				If tmp<>3 Then
					delsince=0
					dellevel=Null ..
					If tmp<>1 Then scorelevel=Null;this=Null;score=Null
				EndIf
			EndIf
			Select tmp
			Case 3
				If Not delsince Then delsince=MilliSecs()
				If delsince And MilliSecs()-delsince>2000 And dellevel<>s Then
					DeleteHighscore s
					scorelevel=s
					LoadHighscore s, this, score
					newload=1
					dellevel=s
				EndIf
			Case 2
				If oklev Then
					dir=s+"/"
					currentlevel=INITLEV
					this=Null;score=Null
					Main
					dir=""
					scorelevel=Null
				EndIf
			Case 1
				If s<>scorelevel Then
					LoadHighscore s, this, score
					scorelevel=s
					oklev=0
					If FileType(s+"/"+INITLEV)=1 Then
						oklev=1
						If FileSize(s+"/"+INITLEV)<5 Or iscorrupt(s) Then oklev=0
					EndIf
					newload=0
				EndIf
			EndSelect
			If tmp Then 
				If oklev Then SetColor 255,255,255 Else SetColor 255,0,0
				DrawText s[..s.length-4],10,30
				If Not oklev Then
					DrawText STR_ERR2,10,50
					If Not iscorrupt(s) Then corruptlevlist:+[s]
				EndIf
			EndIf

			If sy>=GW-20 Then sy=60;sx:+110
		Next
		
		
		sx=120
		sy=10
		If newload<1 Then newload:+0.1
		If oklev Then
			SetAlpha newload
			SetColor 255,255,255
			For Local i:Int=0 Until Min(this.length,score.length)
				s=String(i+1)+". "+this[i]
				s:+" ... "+score[i]+" "+STR_STEPS
				DrawText s,sx,sy
				sy:+16
			Next
			SetAlpha 1
		EndIf
		
		
		Flip 0
		WaitTimer timer
	Until KeyHit(KEY_ESCAPE) Or AppTerminate()
EndFunction

Function Load(file:String, nextlevel:String Var, pos_x:Int Var, pos_y:Int Var, array:Byte[,] Var)
	Local datei:TStream
	Local dx:Int, dy:Int
	Local x:Int, y:Int
	Local teleportsystems:Int
	Local tmp:Int,tmp2:Int
	TTeleport.list=Null
	If FileType(dir+file)<>1 Or FileSize(dir+file)<5 Then array=Null;Return
	datei=ReadFile(dir+file)
	If datei=Null Then array=Null;Return
	tmp=ReadByte(datei)
	If tmp Then nextlevel=ReadString(datei,tmp)
	dx=ReadByte(datei)
	dy=ReadByte(datei)
	pos_x=ReadByte(datei)
	pos_y=ReadByte(datei)
	teleportsystems=ReadByte(datei)
	If dx Mod 2 <> 0 Then dx:+1
	If dy Mod 2 <> 0 Then dy:+1
	array=New Byte[dx,dy]
	#outer_loadloop
	For y=0 Until dy
		For x=0 Until dx Step 2
			If Eof(datei) Then array=Null; Exit outer_loadloop
			tmp=ReadByte(datei)
			array[x,y]=(tmp Shr 4) & $F
			array[x+1,y]=tmp & $F
		Next
	Next
	If array Then
		For teleportsystems=teleportsystems Until 0 Step -1
			x=ReadByte(datei)
			y=ReadByte(datei)
			tmp=ReadByte(datei)
			tmp2=ReadByte(datei)
			TTeleport.Create x,y,tmp,tmp2
		Next
	EndIf
	CloseFile datei
EndFunction

Function iscorrupt:Int(s:String)
	For Local s2:String=EachIn corruptlevlist
		If s=s2 Then Return 1
	Next
	Return 0
EndFunction

Function error(s:String)
	corruptlevlist:+[dir[..dir.length-1]]
	SetClsColor 0,0,255
	Cls
	SetColor 160,160,160
	DrawText s,61,11
	SetColor 255,255,255
	DrawText s,60,10
	DrawText STR_ERROR+":",10,10
	DrawText STR_ANYKEY,10,30
	Flip
	Delay 150
	FlushKeys
	WaitKey
	SetClsColor 0,0,0
EndFunction

Function LoadGFX()
	Local p:TPixmap=LoadPixmap(dir+GFXF)
	FELD_BREITE=PixmapHeight(p)
	If PixmapWidth(p)<>FELD_BREITE*10 Then Return
	p=Null
	gfx=LoadAnimImage(dir+GFXF,FELD_BREITE,FELD_BREITE,0,10)
EndFunction

Function Main()
	gfx=Null ; hg=Null
	FELD_BREITE=FELD_BREITE_STD
	If FileType(dir+GFXF) Then
		LoadGFX
		If gfx=Null Then FELD_BREITE=FELD_BREITE_STD
	EndIf
	If FileType(dir+GFXHG) Then hg=LoadImage(dir+GFXHG)
	Game
	TTeleport.list=Null
	FlushMouse	
EndFunction

Function DrawBoxes(zentral_x:Int, zentral_y:Int, feld:Byte[,])
	Local x:Int, y:Int
	Local dx:Int, dy:Int
	dx=feld.dimensions()[0]
	dy=feld.dimensions()[1]
	If gfx Then SetColor 255,255,255 Else SetColor 160,80,0
	For y=0 Until dy
		For x=0 Until dx
			If feld[x,y] & $4 Then
				If gfx Then ..
					DrawImage gfx,zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,8 ..
				Else ..
					DrawRect zentral_x+x*FELD_BREITE+2,zentral_y+y*FELD_BREITE+2,FELD_BREITE-4, ..
																FELD_BREITE-4
			EndIf
		Next
	Next
EndFunction

Function Draw(zentral_x:Int, zentral_y:Int, feld:Byte[,])
	Local x:Int, y:Int
	Local dx:Int, dy:Int
	dx=feld.dimensions()[0]
	dy=feld.dimensions()[1]
	For y=0 Until dy
		For x=0 Until dx
			If gfx Then
				SetColor 255,255,255
				DrawImage gfx,zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,(feld[x,y]&$3)+4
			Else
				Select feld[x,y] & $3
				Case 0
					SetColor 60,60,60
					DrawRect zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,FELD_BREITE,FELD_BREITE
				Case 2
					SetColor 0,180,0
					DrawRect zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,FELD_BREITE,FELD_BREITE
				Case 3
					SetColor 0,0,0
					DrawRect zentral_x+x*FELD_BREITE,zentral_y+y*FELD_BREITE,FELD_BREITE,FELD_BREITE
					SetColor 255,255,255
					DrawRect zentral_x+x*FELD_BREITE+1,zentral_y+y*FELD_BREITE+1,FELD_BREITE-2, ..
																	FELD_BREITE-2
					SetColor 0,0,0
					DrawRect zentral_x+x*FELD_BREITE+2,zentral_y+y*FELD_BREITE+2,FELD_BREITE-4, ..
																	FELD_BREITE-4
				EndSelect
			EndIf
		Next
	Next
EndFunction


Function checkcompleted:Int(feld:Byte[,])
	Local dx:Int,dy:Int
	Local x:Int, y:Int
	dx=feld.dimensions()[0]
	dy=feld.dimensions()[1]
	For y=0 Until dy
		For x=0 Until dx
			If feld[x,y]&$4 And feld[x,y]&$3<>3 Then Return False
		Next
	Next
	Return True
EndFunction

Function animation_boxes(pos_x:Int, pos_y:Int, zentral_x:Int, zentral_y:Int, ground:TImage, feld:Byte[,])
	MidHandleImage gfx
	For Local x:Float=0 To 359 Step 15
		If hg Then TileImage hg Else Cls
		DrawImage ground,zentral_x,zentral_y
		SetAlpha x/359.0
		SetRotation x
		drawother pos_x,pos_y,zentral_x+FELD_BREITE/2,zentral_y+FELD_BREITE/2,feld
		SetRotation 0
		SetAlpha 1
		Flip 0
		WaitTimer timer
	Next
	SetImageHandle gfx,0,0
EndFunction

Function Game()
	Local pos_x:Int, pos_y:Int, feld:Byte[,]
	Local start_x:Int, start_y:Int
	Local zentral_x:Int, zentral_y:Int
	Local dx:Int, dy:Int
	Local fehlerzeit:Int
	Local start:Int[,]
	Local ground:TImage
	
	Local totalsteps:Int, steps:Int
	
	
	Repeat
		feld=Null
		Load currentlevel, nextlevel, start_x, start_y, feld
		If feld=Null Then error STR_ERR1;Return
		pos_x=start_x
		pos_y=start_y
		dx=feld.dimensions()[0]
		dy=feld.dimensions()[1]
		zentral_x=(GW-feld.dimensions()[0]*FELD_BREITE)/2
		zentral_y=(GH-feld.dimensions()[1]*FELD_BREITE)/2
		start=New Int[dx,dy]
		For Local y:Int=0 Until dy
			For Local x:Int=0 Until dx
				start[x,y]=feld[x,y]
			Next
		Next
		
		ground=CreateImage(FELD_BREITE*dx,FELD_BREITE*dy,1,DYNAMICIMAGE)
		
		Cls
		drawground zentral_x,zentral_y, feld
		'drawother pos_x, pos_y, zentral_x, zentral_y, feld
		SetColor 255,255,255

		GrabImage ground,zentral_x,zentral_y
				
		For Local x:Int=GW To zentral_x Step -25
			If hg Then TileImage hg Else Cls
			SetAlpha 1.0-Double(x-zentral_x)/(GW-zentral_x)
			DrawImage ground,x,zentral_y
			Flip 0
			WaitTimer timer
		Next
		SetAlpha 1
		Cls
		drawground zentral_x, zentral_y, feld
		SetColor 255,255,255
		GrabImage ground,zentral_x,zentral_y
		
		If gfx Then animation_boxes pos_x, pos_y, zentral_x, zentral_y, ground, feld
		
		FlushKeys
		
		steps=0
		Repeat
			Cls
			If hg Then TileImage hg
				
			If fehlerzeit Then
				SetColor 255,0,0
				If fehlerzeit-MilliSecs()<400 Then ..
					SetAlpha (fehlerzeit-MilliSecs())/400.0
				DrawRect zentral_x-5,zentral_y-5,FELD_BREITE*dx+10,FELD_BREITE*dy+10
				SetAlpha 1
			EndIf
			If KeyHit(KEY_BACKSPACE) Then
				For Local y:Int=0 Until dy
					For Local x:Int=0 Until dx
						feld[x,y]=start[x,y]
					Next
				Next
				pos_x=start_x
				pos_y=start_y
				If gfx Then animation_boxes pos_x, pos_y, zentral_x, zentral_y, ground, feld
			EndIf
			SetColor 255,255,255
			DrawImage ground,zentral_x,zentral_y
			drawother pos_x, pos_y, zentral_x, zentral_y, feld

			'drawall pos_x, pos_y, zentral_x, zentral_y, feld
			Select True
			Case KeyHit(KEY_LEFT) Or KeyHit(KEY_A)
				If pos_x>0 And feld[pos_x-1,pos_y]&$3<>0 Then
					If feld[pos_x-1,pos_y] & $4 Then
						If pos_x>1 And feld[pos_x-2,pos_y]&$2 And feld[pos_x-2,pos_y]&$4=0 Then
							pos_x:-1
							feld[pos_x,pos_y]:&(~$4)
							feld[pos_x-1,pos_y]:|$4
							TTeleport.boxteleport feld,pos_x-1,pos_y
						Else
							fehlerzeit=MilliSecs()+600
						EndIf
					Else
						pos_x:-1
					EndIf
				Else
					fehlerzeit=MilliSecs()+600
				EndIf
				steps:+1
				player_dir=3
				TTeleport.playerteleport feld, pos_x, pos_y, -1, 0
			Case KeyHit(KEY_RIGHT) Or KeyHit(KEY_D)
				If pos_x<dx-1 And feld[pos_x+1,pos_y]&$3<>0 Then
					If feld[pos_x+1,pos_y] & $4 Then
						If pos_x+2<dx And feld[pos_x+2,pos_y]&$2 And feld[pos_x+2,pos_y]&$4=0 Then
							pos_x:+1
							feld[pos_x,pos_y]:&(~$4)
							feld[pos_x+1,pos_y]:|$4
							TTeleport.boxteleport feld,pos_x+1,pos_y
						Else
							fehlerzeit=MilliSecs()+600
						EndIf
					Else
						pos_x:+1
					EndIf
				Else
					fehlerzeit=MilliSecs()+600
				EndIf
				steps:+1
				player_dir=2
				TTeleport.playerteleport feld, pos_x, pos_y, 1, 0
			Case KeyHit(KEY_UP) Or KeyHit(KEY_W)
				If pos_y>0 And feld[pos_x,pos_y-1]&$3<>0 Then
					If feld[pos_x,pos_y-1] & $4 Then
						If pos_y>1 And feld[pos_x,pos_y-2]&$2 And feld[pos_x,pos_y-2]&$4=0 Then
							pos_y:-1
							feld[pos_x,pos_y]:&(~$4)
							feld[pos_x,pos_y-1]:|$4
							TTeleport.boxteleport feld,pos_x,pos_y-1
						Else
							fehlerzeit=MilliSecs()+600
						EndIf
					Else
						pos_y:-1
					EndIf
				Else
					fehlerzeit=MilliSecs()+600
				EndIf
				steps:+1
				player_dir=0
				TTeleport.playerteleport feld, pos_x, pos_y, 0, -1
			Case KeyHit(KEY_DOWN) Or KeyHit(KEY_S)
				If pos_y<dy-1 And feld[pos_x,pos_y+1]&$3<>0 Then
					If feld[pos_x,pos_y+1] & $4 Then
						If pos_y+2<dy And feld[pos_x,pos_y+2]&$2 And feld[pos_x,pos_y+2]&$4=0 Then
							pos_y:+1
							feld[pos_x,pos_y]:&(~$4)
							feld[pos_x,pos_y+1]:|$4
							TTeleport.boxteleport feld,pos_x,pos_y+1
						Else
							fehlerzeit=MilliSecs()+600
						EndIf
					Else
						pos_y:+1
					EndIf
				Else
					fehlerzeit=MilliSecs()+600
				EndIf
				steps:+1
				player_dir=1
				TTeleport.playerteleport feld, pos_x, pos_y, 0, 1
			EndSelect
			
			SetAlpha 0.5
			SetColor 0,0,0
			DrawRect 0,0,200,50
			SetAlpha 1
			SetColor 255,255,255
			DrawText STR_TSTEPS+": "+(steps+totalsteps),5,5
			DrawText STR_STEPS+": "+steps,5,25
			
			Flip 0
			WaitTimer timer
			If KeyHit(KEY_ESCAPE) Or AppTerminate() Then Return
		Until checkcompleted(feld)
		totalsteps:+steps
		Cls
		If hg Then TileImage hg
		drawground zentral_x, zentral_y, feld
		drawother pos_x, pos_y, zentral_x, zentral_y, feld
		SetColor 255,255,255
		GrabImage ground,zentral_x,zentral_y
		Flip 0
		Delay 250
		For Local x:Int=GW To zentral_x Step -25
			If hg Then TileImage hg Else Cls
			SetAlpha Double(x-zentral_x)/(GW-zentral_x)
			DrawImage ground,x-(GW-zentral_x),zentral_y
			Flip 0
			WaitTimer timer
		Next
		SetAlpha 1
		ground=Null
		currentlevel=nextlevel
		nextlevel=""
	Until Not currentlevel
	Delay 150
	FlushKeys
	SaveScore totalsteps
EndFunction

Function SaveScore(steps:Int)
	Local name:String[], score:Int[]
	Local newname:String, get:Byte
	LoadHighscore dir, name, score
	For Local i:Int=0 Until score.length
		If steps<score[i] Then
			SetColor 255,255,255
			Repeat
				Cls
				
				DrawText STR_SCORE+": "+steps,GW/2-105,GH/2-30
				DrawText STR_NAME+":",GW/2-105,GH/2-7
				DrawText newname,GW/2-60,GH/2-7
				
				get=GetChar()
				If get=8 Then newname=newname[..newname.length-1]
				If newname.length<SCORE_NAMELEN Then
					If MilliSecs() Mod 700 < 350 Then DrawRect GW/2-55+TextWidth(newname),GH/2+3,8,5
					If (get>=65 And get<=90) Or (get>=48 And get<=57) Then
						newname:+Chr(get)
					ElseIf get>=97 And get<=122 Then
						newname:+Chr(get-32)
					EndIf
				EndIf
				
				Flip 0
				Delay 20
			Until KeyHit(KEY_RETURN)
			If newname Then
				name=name[..i]+[newname]+name[i..]
				name=name[..SCORE_PLAETZE]
				score=score[..i]+[steps]+score[i..]
				score=score[..SCORE_PLAETZE]
				SaveHighscore dir, name, score
			EndIf
			Exit
		EndIf
	Next
EndFunction

Function drawground(zentral_x:Int,zentral_y:Int,feld:Byte[,])
	Draw zentral_x, zentral_y, feld
	TTeleport.drawall zentral_x, zentral_y
EndFunction

Function drawother(pos_x:Int,pos_y:Int,zentral_x:Int,zentral_y:Int,feld:Byte[,])
	DrawBoxes zentral_x, zentral_y, feld
	If gfx Then
		SetColor 255,255,255
		DrawImage gfx,zentral_x+pos_x*FELD_BREITE,zentral_y+pos_y*FELD_BREITE,player_dir
	Else
		SetColor 0,0,255
		DrawOval zentral_x+pos_x*FELD_BREITE,zentral_y+pos_y*FELD_BREITE,FELD_BREITE,FELD_BREITE
	EndIf
EndFunction

